#!/usr/bin/perl

# from the data, print a list of class reps.

use monster;

# Use the class ID data to determine what is left to do

@void = (37,43,49,53,58,61,63,64,65,67,72,73,74,75,76,77,79,80,81,82,83,85,86,89,90,91,96,97,98,99,100,101,102,103,106,107,108,109,111,112,113,114,115,116,117,118); # orders that don't occur

$bads = 0;
for($order=2; $order<120; $order++) {
  if( $order == $void[$bads] ) {
    $bads++;
  }
  else {
    print"\n";
@power = monster::pmap($order);

# Get the conjugacy class ID data for this order
open(F, "cid.data");
$found = 0;
while($found == 0) {
  $line = <F>;
  @things = split(/\,/, $line);
  if( $things[0] eq $order ) {
    $found = 1;
  }
}
chomp($line);
$header = $line;

$found = 0;
@list = ();
while($found == 0) {
  $line = <F>;
  @things = split(/\,/, $line);
  if( $things[0] =~ /\d+/ ) {
    $found = 1;
  }
  else {
  chomp($line);
    push(@list, $line);
  }
}

close(F);


# Foreach conjugacy class, find an element in it
#  Formulate the traces array, then use find.pl

# Convert $header into @traces indices


if( $header =~ /\*/ ) {
  $number = monster::find($order,1,n,x,x,x,x,x,x,x,x); 
  $number++;
  
  $elt = monster::find($order,1,e,x,x,x,x,x,x,x,x);
  print "$order"."AB: ($number) $elt\n"; #"Elements of order $order are algebraically conjugate\n";
}
elsif( $header =~ /\,1/ ) {
  $number = monster::find($order,1,n,x,x,x,x,x,x,x,x); 
  $number++;
  
  $elt = monster::find($order,1,e,x,x,x,x,x,x,x,x);
  if( $elt eq "0" ) {
    print "$order: no elements\n";
  }
  else {
    print "$order"."A: ($number) $elt\n";
  }
}
else {

@headers = split(/\,/, $header);

for($i=1; $i<=$#headers; $i++) {
  $examine = $headers[$i];
  if( $examine !~ /P/ ) {
    if( $examine eq "2" ) {
      $headers[$i] = 0;
    }
    elsif( $examine eq "7" ) {
      $headers[$i] = 4;
    }
    else {
      monster::error("Wrong header in cid.data (cid.pl)");
    }
  }
  elsif( $examine =~ /(\d+) P(\d+)/ ) {
    $mod = $1;
    $pow = $2;
    if( $mod eq "2") {
      $start = 0;
    }
    elsif( $mod eq "7") {
      $start = 4;
    }
    else {
      monster::error("Wrong header in cid.data (cid.pl)");
    }
    for($j=1; $j<5; $j++) {
      if($pow eq $power[$j]) {
        $headers[$i] = $start + $j -1;
      }
    }
  }
  else {
    monster::error("Wrong header in cid.data (cid.pl)");
  }
}

# make the @traces array


foreach $class(@list) {
  @traces = (x,x,x,x,x,x,x,x);
  ($name,@tr) = split(/\,/, $class);
  
  for($i=0; $i<=$#tr; $i++) {
    $traces[$headers[$i+1]] = $tr[$i];
  }
  
  for($i=0; $i<8; $i++) {
    if( $traces[$i] !~ /\d+/ ) {
      $traces[$i] = "x";
    }
  }
  
  print "$order$name: ";
  $number = monster::find($order,1,n,@traces); 
  $number++;
  print "($number) ";

  $elt = monster::find($order,1,e,@traces);
  if( $elt eq "0" ) {
    print "\n"; #No elements
  }
  else {
    print "$elt\n";
  }
}
}
}
}

